<template>
	<a-drawer
		:title="formData.id ? '编辑电子锁预约' : '增加电子锁预约'"
		:width="600"
		:visible="visible"
		:destroy-on-close="true"
		:footer-style="{ textAlign: 'right' }"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="企业客户：" name="depotId">
				<a-select v-model:value="formData.depotId" placeholder="请选择企业客户" :options="depotIdOptions" @change="depotIdChange"/>
			</a-form-item>
			<a-form-item label="库位：" name="shedName">
				<a-select v-model:value="formData.shedName" placeholder="请选择库位" :options="depotShedOptions"/>
			</a-form-item>
			<a-form-item label="锁名称：" name="lockName">
				<a-input v-model:value="formData.lockName" placeholder="请输入锁名称" allow-clear/>
			</a-form-item>
			<a-form-item label="描述：" name="remark">
				<a-textarea v-model:value="formData.remark" placeholder="请输入描述" allow-clear :auto-size="{ minRows: 3, maxRows: 10 }"/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</a-drawer>
</template>

<script setup name="depotLockBookForm">
import tool from '@/utils/tool'
import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import depotLockBookApi from '@/api/biz/depotLockBookApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import depotGrainInfoApi from "@/api/biz/depotGrainInfoApi";
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)
const depotIdOptions = ref([])
const depotShedOptions = ref([])

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	} else {
	}
	dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
		depotIdOptions.value = data
	})
	depotIdLoad()
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	depotId: [required('请输入项目编码')],
	shedName: [required('请输入库位')],
	lockName: [required('请输入锁名称')],
}
// 粮库加载
const depotIdLoad = () => {
	if (formData.value.depotId)
		dictOptionsApi.options({'dictValue': '库位', depotId: formData.value.depotId}).then((data) => {
			depotShedOptions.value = data
		})
}
// 粮库加载
const depotIdChange = () => {
	formData.value.shedName = ''
	depotIdLoad()
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value
		.validate()
		.then(() => {
			submitLoading.value = true
			const formDataParam = cloneDeep(formData.value)
			depotLockBookApi
				.depotLockBookSubmitForm(formDataParam, !formDataParam.id)
				.then(() => {
					onClose()
					emit('successful')
				})
				.finally(() => {
					submitLoading.value = false
				})
		})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
